﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Input;

namespace BindingSelectedNode
{
    public class MainVM : INotifyPropertyChanged
    {
        public MainVM()
        {
            DataItems = GetData();
        }

        public ObservableCollection<Continent> DataItems
        {
            get { return data; }
            set
            {
                data = value;
                OnPropertyChanged("DataItems");
            }
        }

        public object ActiveDataItem
        {
            get { return active; }
            set
            {
                active = value;
                OnPropertyChanged("ActiveDataItem");
            }
        }

        
        public event PropertyChangedEventHandler PropertyChanged;
        private ObservableCollection<Continent> data;
        private object active;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }

        public void SetSelectedNode()
        {
            Random r = new Random();
            int level = r.Next(3);

            switch (level)
            {
                case 0:
                    {
                        ActiveDataItem = DataItems[r.Next(DataItems.Count)];
                    }
                    break;

                case 1:
                    {
                        Continent c =  DataItems[r.Next(DataItems.Count)];
                        ActiveDataItem = c.Countres[r.Next(c.Countres.Count)];
                    }
                    break;
                case 2:
                    {
                        Continent c = DataItems[r.Next(DataItems.Count)];
                        Country cc =  c.Countres[r.Next(c.Countres.Count)];
                        ActiveDataItem = cc.Cities[r.Next(cc.Cities.Count)];
                    }
                    break;
                default:
                    break;
            }
        }

        private ObservableCollection<Continent> GetData()
        {
            ObservableCollection<Continent> data = new ObservableCollection<Continent>();
            data.Add(
             new Continent
             {
                 Name = "Africa",
                 Countres = new ObservableCollection<Country>()
                    {
                        new Country()
                        {
                            Name = "Algeria",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Algiers"},
                                new City {Name = "Oran"},
                            }
                        },
                        new Country()
                        {
                            Name = "Angola",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Soyo"},
                                new City {Name = "Ndalatando"},
                                new City {Name = "Ambriz"},
                            }
                        },
                        new Country()
                        {
                            Name = "Cape Verde",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Mindelo"},
                                new City {Name = "Assomada"},
                            }
                        }
                    }
             });

            data.Add(
                new Continent
                {
                    Name = "Asia",
                    Countres = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Cambodia",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Phnom Penh"},
                                                new City {Name = "Koh Kong"},
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "China",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Shanghai"},
                                                new City {Name = "Beijing"},
                                                new City {Name = "Tianjin"},
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "Japan",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Tokyo"},
                                                new City {Name = "Yokohama"},
                                                new City {Name = "Sapporo"},
                                            }
                                        }
                                    }
                });

            data.Add(new Continent
            {
                Name = "Australia",
                Countres = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Australia",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Sydney"},
                                                new City {Name = "Melbourne"},
                                                new City {Name = "Perth"},
                                            }
                                        }
                                    }
            });

            data.Add(new Continent
            {
                Name = "Europe",
                Countres = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Germany",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Berlin"},
                                                new City {Name = "Hamburg"}
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "Italy",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Milan"},
                                                new City {Name = "Naples"},
                                                new City {Name = "Rome"}
                                            }
                                        }
                                    }
            });

            return data;
        }

    

    }

    public class Continent
    {
        public string Name { get; set; }
        public ObservableCollection<Country> Countres { get; set; }
    }

    public class Country
    {
        public string Name { get; set; }
        public ObservableCollection<City> Cities { get; set; }
    }

    public class City
    {
        public string Name { get; set; }
    }
}
